
#ifndef _CRITERES_H
#define _CRITERES_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <global.h>
#include <alphabet.h>

/******************************************************************************/
/* STRUCTURE DE STOCKAGE DES CRITERES DE RECHERCHE                            */
/******************************************************************************/
typedef struct  struct_fourchette
    {
    LongSeq     min;
    LongSeq     max;
    }   Fourchette, *P_Fourchette;

typedef struct  struct_criteres
    {
    LongSeq     **compobloc;
    LongSeq     *maxerrblocs;
    LongSeq     *compo;
    Fourchette  *longbloc;
    Fourchette  *saut;
    LongSeq     *delta;
    Flag        *flag_compobloc;
    long int    nbsymb;
    Fourchette  longueur;
    LongSeq     maxerr;
    LongSeq     maxinter; /* Nb max d'intervalles delta dans un saut          */
    LongSeq     maxsaut;  /* Longueur max d'un saut                           */
    NbSeq       quorum;
    char        bloc;
    Flag        flag_compo;
    }   Criteres, *P_Criteres;


/******************************************************************************/
/* FONCTIONS PUBLIQUES                                                        */
/******************************************************************************/

void    setCompo(P_Criteres cr, char **argv, int argc);

int     initFiles(FILE **f, char *nom, P_Criteres cr);

int     delta2File(LongSeq *deltatab, P_Criteres cr);

int     file2Delta(int pos, LongSeq *deltatab, P_Criteres cr);

int     addSaut2Code(int oldcode, LongSeq saut, LongSeq curbloc, P_Criteres cr);

void    initTabSauts(P_Criteres);

void    allocBloc(P_Criteres cr, int bloc);

#endif
