
#ifndef _CRITERES_H
#define _CRITERES_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "global.h"

/******************************************************************************/
/* STRUCTURE DE STOCKAGE DES CRITERES DE RECHERCHE                            */
/******************************************************************************/
typedef struct  struct_fourchette
    {
    LongSeq     min;
    LongSeq     max;
    }   Fourchette, *P_Fourchette;

/******************************************************************************/
/* Seuls sont necessaires pour la recherche: maxerr, bloc, maxerrbloc,        */
/* longbloc.max, saut, multiblocs, code2Sauts. Le reste est superflu          */
/* (utilise par sigstat ou converter) et n'a donc pas de methodes get/set.    */
/******************************************************************************/
typedef struct  struct_criteres
    {
    Fourchette  *longbloc;
    Fourchette  *saut;
    LongSeq     *maxerrblocs;
    int         **code2Sauts;
    char        alphaseq[128];
    char        ficalph[128];
    long int    nbsymb;
    Fourchette  longmod;
    LongSeq     maxerr;
    NbSeq       nbtotseq;
    NbBlocs     bloc;
    Flag        multiblocs;
    }   Criteres, *P_Criteres;


/******************************************************************************/
/* FONCTIONS PUBLIQUES                                                        */
/******************************************************************************/

Flag    setBloc(P_Criteres, NbBlocs);
Flag    setLongueurBloc(P_Criteres, NbBlocs num_bloc, LongSeq lon);
Flag    setErreurBloc(P_Criteres, NbBlocs num_bloc, LongSeq erreur);
void    setErreurGlobal(P_Criteres, LongSeq erreur);
Flag    setSaut(P_Criteres, NbBlocs num_bloc, LongSeq min, LongSeq max);
NbBlocs getBloc(Criteres);
LongSeq getLongueurBloc(Criteres,NbBlocs num_bloc);
LongSeq getErreurBloc(Criteres, NbBlocs num_bloc);
LongSeq getErreurGlobale(Criteres);
LongSeq getJoker(Criteres);
Fourchette getSaut(Criteres,NbBlocs num_bloc);
int     maxLongMod(Criteres);
void    afficheCriteres(Criteres, FILE *);
Flag    verifCriteres(Criteres);
void    initCriteres(Criteres *);
Flag    chargeCriteres(Criteres *, char *);


int     addSaut2Code(int oldcode, LongSeq saut, LongSeq curbloc, P_Criteres cr);

void    initTabSauts(P_Criteres);

Flag    allocBloc(P_Criteres cr, NbBlocs bloc);

#endif
