#include <global.h>

int symb2int[256]={-1};

/******************************************************************************/
/* fatalError                                                                 */
/******************************************************************************/
/* Gestion des erreurs FATALES!                                               */
/******************************************************************************/
void fatalError(char *msg)
{
fprintf(stderr,"Error: %s\n",msg);
exit(1);
}

/******************************************************************************/
/* warning                                                                    */
/******************************************************************************/
void warning(char *msg)
{
fprintf(stderr,"Warning: %s\n",msg);
}

/******************************************************************************/
/* initEntiers                                                                */
/******************************************************************************/
void initEntiers(void)
{
int i;

for(i=0;i<256;i++)
    symb2int[i] = -1;

symb2int[(int)'A']  = 0;
symb2int[(int)'C']  = 1;
symb2int[(int)'G']  = 2;
symb2int[(int)'T']  = 3;
symb2int[(int)'$']  = 4;
}

/******************************************************************************/
/* entiers                                                                    */
/******************************************************************************/
/* Conversion des symboles vers les entiers                                   */
/******************************************************************************/
int entiers(char c)
{
int ret;

ret = symb2int[(int)c];
if(ret == -1)
    {
    fprintf(stderr,"-- %c --",c);
    fatalError("Unknown character, non A,C,G,T or $");
    }

return ret;
}


/******************************************************************************/
/* entree                                                                     */
/******************************************************************************/
void entree(void)
{
printf("\n-- Type ENTER\n");
fflush(stdin);
getchar();
}
