#ifndef ALLOCATEUR_H
#define ALLOCATEUR_H

#include<structures.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <bit_tab.h>


/*
                                              SINGLE_TAB_SIZE
			                   __________|___________
                                         /                       \
                         /  ----            
                         |  |  |   ----> [ | | | | | | | | | ....]
                         |  ----
                         |  |  |   ----> [ | | | | | | | | | ....]   
ALLOC_NOEUD_TAB_STEP -   ----
                         |  |  |   ----> [ | | | | | | | | | ....]
			 |  ----
			 |  |  |   ----> [ | | | | | | | | | ....]
			 \  ----
			    ....
 */

Noeud *Alloc_Noeud(void );
Feuille *Alloc_Feuille(void );
Liste *Alloc_Liste(void);
void Free_Liste(Liste *l);
void Free_All_Liste_Cell(void);
void Init_Allocateurs(void );


void Free_Arbre(Noeud *Racine);

typedef struct _cell
{
  struct _cell *suivant;
  unsigned char *data;
  int current;
  int max;
}Alloc_Cell;

typedef struct _allocateur
{
  Alloc_Cell *first;
  Alloc_Cell *last;
}Allocateur;

#endif
